



try:
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *


# from Products.Archetypes.public import Schema, BaseSchema, BaseFolderSchema
# from Products.Archetypes.BaseContent import BaseContent 
# from Products.Archetypes.BaseFolder import BaseFolder
# from Products.Archetypes.public import TextField, StringField
# from Products.Archetypes.public import TextAreaWidget, RichWidget, SelectionWidget, EpozWidget, VisualWidget
# from Products.Archetypes.public import BaseContent, registerType
from Products.Archetypes.interfaces.metadata import IExtensibleMetadata
from Products.ATSchemaEditorNG.SchemaEditor import SchemaEditor

from Products.CMFCore import CMFCorePermissions

import Products

if hasattr(Products,'PloneArticle_no'):
	plone_article_available = 1
else:
	plone_article_available = 0

if plone_article_available:
	from Products.PloneArticle.PloneArticle import PloneArticle
	from Products.PloneArticle.ArticleCore import ArticleContents
#	from Products.PloneArticle.PloneArticle import ArticleLock
#	from Products.PloneArticle.BaseArchetypesArticle import BaseArchetypesArticle

if hasattr(Products,'PloneExFile_no'):
	plone_exfile_available = 1
else:
	plone_exfile_available = 0

if plone_exfile_available:
	from Products.PloneExFile.ExFile import PloneExFile


	
if hasattr(Products,'ATContentTypes'):
	atcontenttypes_available = 1
else:
	atcontenttypes_available = 0

	
from webdav.WriteLockInterface import WriteLockInterface
from webdav.LockItem import LockItem

from AccessControl import ClassSecurityInfo
import string
from Products.GenericPloneContent.GenericParentManagedSchema import GenericParentManagedSchema
if plone_article_available:
	class GenericArticleContent(GenericParentManagedSchema,PloneArticle):
		"""An Archetype example type"""
		
		# Since we have customized the default Metadata schema into ArticleInfos...
		#schema = BaseContentMixin.schema # + .... (add your own schemas)
		#schema = BaseContent.schema
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Article Content"
		#     schema = BaseSchema
		#                                        #
		security = ClassSecurityInfo()
		security.declareProtected(CMFCorePermissions.View, 'SearchableText')
		def SearchableText(self):
			"Returns a concatenation of all searchable text"
			ret = ""
			for field in self.Schema().filterFields(isMetadata=0):
				val = field.get(self)
				if val:
					ret += str(val) + ' '
			ret += string.join(map(lambda x: x.SearchableText(), self.listAttachments()), " ") + " "
			ret += string.join(map(lambda x: x.title_or_id(), self.listImages()), " ")
			return ret
		
	
	registerType(GenericArticleContent)


class GenericContent(GenericParentManagedSchema, BaseContent):
    """ Target content type to edit schema on """
    __implements__ = (WriteLockInterface,) 
    meta_type = portal_type = "Generic Content"

registerType(GenericContent)

class GenericFolder(GenericParentManagedSchema, BaseFolder):
    """ Target content type to edit schema on """
    __implements__ = (WriteLockInterface,)
    meta_type = portal_type = "Generic Folder"

registerType(GenericFolder)

if atcontenttypes_available:
	from Products.ATContentTypes.types.ATDocument import ATDocument
	class GenericDocument(GenericParentManagedSchema, ATDocument):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Document"
	registerType(GenericDocument)

	from Products.ATContentTypes.types.ATEvent import ATEvent
	class GenericEvent(GenericParentManagedSchema, ATEvent):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Event"
	registerType(GenericEvent)

	from Products.ATContentTypes.types.ATFile import ATFile
	class GenericFile(GenericParentManagedSchema, ATFile):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic File"
	registerType(GenericFile)

	from Products.ATContentTypes.types.ATFavorite import ATFavorite
	class GenericFavorite(GenericParentManagedSchema, ATFavorite):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Favorite"
	registerType(GenericFavorite)

	from Products.ATContentTypes.types.ATImage import ATImage
	class GenericImage(GenericParentManagedSchema, ATImage):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Image"
	registerType(GenericImage)

	from Products.ATContentTypes.types.ATLink import ATLink
	class GenericLink(GenericParentManagedSchema, ATLink):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Link"
	registerType(GenericLink)
	
	from Products.ATContentTypes.types.ATNewsItem import ATNewsItem
	class GenericNewsItem(GenericParentManagedSchema, ATNewsItem):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic NewsItem"
	registerType(GenericNewsItem)
	
	from Products.ATContentTypes.types.ATTopic import ATTopic
	class GenericTopic(GenericParentManagedSchema, ATTopic):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic Topic"
	registerType(GenericTopic)
	
	
	
if plone_exfile_available:
	class GenericExFile(GenericParentManagedSchema, PloneExFile):
		""" Target content type to edit schema on """
		__implements__ = (WriteLockInterface,)
		meta_type = portal_type = "Generic ExFile"
		schema = PloneExFile.schema 
		#    schema = BaseFolderSchema
		security = ClassSecurityInfo()
		security.declareProtected(CMFCorePermissions.View, 'SearchableText')
		def SearchableText(self):
			"Returns a concatenation of all searchable text"
			ret = ""
		#	import pdb;pdb.set_trace()
			for field in self.Schema().filterFields(isMetadata=0):
				if hasattr(field,'getPreview'):
					val = field.getPreview(self).replace('&nbsp;','')
				else:
					val = field.get(self)
				if val:
					ret += str(val) + ' '
		#	ret += string.join(map(lambda x: x.SearchableText(), self.listAttachments()), " ") + " "
		#	ret += string.join(map(lambda x: x.title_or_id(), self.listImages()), " ")
			return ret

	registerType(GenericExFile)

